
\documentclass{article}
\usepackage{palatino}
\title{Pequeno caso de estudo --- ``Pretty-printing'' de Directorias Unix em Micro-\LaTeX}
\author{LEI --- LI1/1112}
\date{Dez.\ 2011}

%include polycode.fmt
\begin{document}
\maketitle

Apresenta-se de seguida uma pequena biblioteca em Haskell que representa nesta linguagem
a estrutura b\'asica de uma directoria e seus ficheiros, de que se faz
``pretty-printing'' para \LaTeX.

\subsection*{M\'odulo e depend\^encias}
\begin{code}

module Dir where

import TeX
import Data.List

\end{code}

\subsection*{Tipos b\'asicos}
Ficheiros:

\begin{code}

data File = File {
     perms :: String ,
     nrlnk :: String ,
     owner :: String ,
     group :: String ,
     size :: Int ,
     month :: String ,
     day  :: String ,
     time :: String ,
     name :: String } deriving Show

\end{code}
Directorias:

\begin{code}

data Dir = Dir {
     total :: Int,
     files :: [File]
     } deriving Show

\end{code}

\subsection*{Convers\~ao para Micro-\LaTeX}

\subsubsection*{Fun\c c\~ao principal}
\begin{code}

prettyprint :: Dir -> [Char]
prettyprint = texTeX2txt . (latex "article") . dirDir2TeX 

\end{code}

\subsubsection*{Fun\c c\~oes auxiliares}
A que converte directorias:

\begin{code}
dirDir2TeX :: Dir -> TeX
dirDir2TeX (Dir t fs) =
     quote $
     string ("Total: " ++ show t) $
     description (map dirFile2TeX fs)

\end{code}
A que converte ficheiros:

\begin{code}
dirFile2TeX :: File -> TeX
dirFile2TeX (File p x o g s m d t n) =
     descitem (STR "File: ") $
     string n $
     quote $
     tabular "|l|l|" $
       header $
       wrap nlhline [
          strTabRow ["perms", p]
        , strTabRow ["nrlnk", x]
        , strTabRow ["owner", o]
        , strTabRow ["group", g]
        , strTabRow ["size", show s]
        , strTabRow ["month", m]
        , strTabRow ["day", d]
        , strTabRow ["time", t]
        , strTabRow ["name", n]
     ]
     where header = ([hline,strTabRow ["Attribute", "Data"]]++)

\end{code}

\end{document}
